install 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios
  21. type="ERROR"
  22. exitNum=$1
  23. codeNum=$2
  24. extraInfo=$3
  25. case $codeNum in
  26. 1)
  27. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  28. ;;
  29. 2)
  30. error="$type $codeNum:\tError interno (seleción express).\n"
  31. ;;
  32. 3)
  33. error="$type $codeNum:\tError interno (seleción avanzada).\n"
  34. ;;
  35. 100)
  36. error="$type $codeNum:\tError interno (seleción del servidor web).\n"
  37. ;;
  38. 101)
  39. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  40. ;;
  41. 102)
  42. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  43. ;;
  44. 103)
  45. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  46. ;;
  47. 104)
  48. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  49. ;;
  50. 105)
  51. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  52. ;;
  53. 200)
  54. error="$type $codeNum:\tError interno (seleción de base de datos).\n"
  55. ;;
  56. 201)
  57. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 202)
  60. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  61. ;;
  62. 203)
  63. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  64. ;;
  65. 204)
  66. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  67. ;;
  68. 205)
  69. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  70. ;;
  71. 206)
  72. type="WARNING"
  73. error="$type $codeNum:\tUsuario 'root' ya dispone de contraseña.\n"
  74. ;;
  75. 207)
  76. error="$type $codeNum:\tImposible cambiar la contraseña de 'root'.\n"
  77. ;;
  78. 208)
  79. error="$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior.\n"
  80. ;;
  81. 209)
  82. error="$type $codeNum:\tImposible eliminar usuarios anónimos.\n"
  83. ;;
  84. 210)
  85. type="WARNING"
  86. error="$type $codeNum:\tImposible eliminar bases de datos de pruebas.\n"
  87. ;;
  88. 211)
  89. type="WARNING"
  90. error="$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas.\n"
  91. ;;
  92. 212)
  93. error="$type $codeNum:\tImposible recargar base de datos.\n"
  94. ;;
  95. 800)
  96. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  97. ;;
  98. 801)
  99. error="$type $codeNum:\t'whiptail' no instalado.\n"
  100. ;;
  101. 802)
  102. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  103. ;;
  104. 803)
  105. error="$type $codeNum:\t'apt-get' no instalado.\n"
  106. ;;
  107. 804)
  108. error="$type $codeNum:\t'yum' no instalado.\n"
  109. ;;
  110. 805)
  111. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  112. ;;
  113. 806)
  114. error="$type $codeNum:\t'ufw' no instalado.\n"
  115. ;;
  116. 807)
  117. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  118. ;;
  119. 900)
  120. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  121. ;;
  122. 901)
  123. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  124. ;;
  125. 902)
  126. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  127. ;;
  128. *)
  129. error="ERROR 13:\tError interno (comprobación de errores)\n"
  130. exitNum=1
  131. codeNum=13
  132. ;;
  133. esac
  134. if [ $exitNum -ne 0 ];then
  135. printf "$error"
  136. if [ $type = "ERROR" ];then
  137. exit $codeNum
  138. fi
  139. fi
  140. unset error exitNum codeNum type
  141. }
  142. OSInfo() {
  143. #printf "Detectando SO..."
  144. OS=$(uname -s)
  145. if [ $OS = "Linux" ]; then
  146. OS="GNU/Linux"
  147. if [ -f /etc/os-release ]; then
  148. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  149. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  150. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  151. for i in $ID_LIKE; do
  152. #printf "$i\n"
  153. case $i in
  154. debian|ubuntu)
  155. debianOS=true
  156. break
  157. ;;
  158. rhel|fedora)
  159. rhelOS=true
  160. break
  161. ;;
  162. *)
  163. debianOS=false
  164. rhelOS=false
  165. ;;
  166. esac
  167. done
  168. elif [ -f /etc/debian-version ]; then
  169. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  170. DIST="Debian"
  171. REV=""
  172. ID_LIKE="debian"
  173. debianOS=true
  174. elif [ -f /etc/redhat-release ]; then
  175. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  176. DIST="Red-Hat"
  177. REV=""
  178. ID_LIKE="rhel"
  179. rhelOS=true
  180. else
  181. # Other Linux (No Soportado)
  182. DIST=""
  183. REV=""
  184. ID_LIKE=""
  185. fi
  186. else
  187. # UNIX, OS X, ... (No Soportado)
  188. DIST=$OS
  189. REV=""
  190. fi
  191. #printf " $OS $DIST $REV\n"
  192. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  193. }
  194. comprobarRoot() {
  195. comprobarError $(id -u) 800
  196. }
  197. comprobarDependencias() {
  198. # Comprobamos whiptail
  199. which whiptail > /dev/null 2>&1
  200. comprobarError $? 801
  201. # Comprobamos hostnamectl
  202. which hostnamectl > /dev/null 2>&1
  203. comprobarError $? 802
  204. if [ $debianOS = true ];then
  205. # Comprobamos apt-get
  206. which apt-get > /dev/null 2>&1
  207. comprobarError $? 803
  208. # Actualizamos base de datos del repositorio
  209. printf "Actualizando repositorio APT..."
  210. result=$(apt-get -q -y update)
  211. comprobarError $? 805 $result
  212. printf " OK.\n"
  213. # Comprobamos Firewall (ufw)
  214. which ufw > /dev/null 2>&1
  215. comprobarError $? 806
  216. fi
  217. if [ $rhelOS = true ]; then
  218. # Comprobamos yum
  219. which yum > /dev/null 2>&1
  220. comprobarError $? 804
  221. # Actualizamos base de datos del repositorio
  222. printf "Actualizando repositorio YUM..."
  223. result=$(yum -y makecache 2>&1)
  224. comprobarError $? 805 $result
  225. printf " OK.\n"
  226. # Comprobamos Firewall (firewall-cmd)
  227. which firewall-cmd > /dev/null 2>&1
  228. comprobarError $? 807
  229. fi
  230. }
  231. inicializarVariables() {
  232. debianOS=false
  233. rhelOS=false
  234. apacheOn=false
  235. nginxOn=false
  236. mySQLOn=false
  237. mariaDBOn=false
  238. phpOn=false
  239. mediaWikiOn=false
  240. moodleOn=false
  241. actualizacionesOn=false
  242. }
  243. instalacionExpress() {
  244. apacheOn=true
  245. mariaDBOn=true
  246. phpOn=true
  247. mediaWikiOn=true
  248. moodleOn=true
  249. actualizacionesOn=true
  250. # Preguntas mínimas
  251. establecerFQDN
  252. leerSQLPasswd
  253. }
  254. mostrarBienvenida() {
  255. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  256. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --ok-button "Salir"
  257. exit 1
  258. fi
  259. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --yes-button "Continuar" --no-button "Salir"
  260. comprobarError $? 1
  261. }
  262. mostrarExpress() {
  263. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  264. "Express" "Instalación rápida" ON \
  265. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  266. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  267. comprobarError $? 1
  268. case $express in
  269. Express)
  270. instalacionExpress
  271. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  272. ;;
  273. Avanzada)
  274. mostrarAvanzada
  275. ;;
  276. *)
  277. comprobarError 1 2
  278. ;;
  279. esac
  280. }
  281. mostrarAvanzada() {
  282. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  283. "WebServer" "Instalar servidor web http/https" ON \
  284. "Database" "Instalar una base de datos SQL" ON \
  285. "PHP" "Instala PHP7" ON \
  286. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  287. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  288. "Moodle" "Instalar campus virtual con Moodle" ON \
  289. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  290. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  291. comprobarError $? 1
  292. # Mejora: autodetección de componentes ya instalados
  293. for i in $componentes; do
  294. case $i in
  295. \"WebServer\")
  296. mostrarWebServer
  297. ;;
  298. \"Database\")
  299. mostrarDatabase
  300. ;;
  301. \"PHP\")
  302. phpOn=true
  303. ;;
  304. \"SSL/TLS\")
  305. # 2 Opciones: Let's Encrypt o Autofirmado
  306. ;;
  307. \"MediaWiki\")
  308. mediaWikiOn=true
  309. ;;
  310. \"Moodle\")
  311. moodleOn=true
  312. ;;
  313. \"Actualizaciones\")
  314. actualizacionesOn=true
  315. ;;
  316. *)
  317. comprobarError 1 3
  318. ;;
  319. esac
  320. done
  321. }
  322. mostrarWebServer() {
  323. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  324. "Apache" "Instalar el servidor web Apache2" ON \
  325. "Nginx" "Instalar el servidor web Nginx" OFF \
  326. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  327. comprobarError $? 1
  328. case $webServer in
  329. Apache)
  330. apacheOn=true
  331. ;;
  332. Nginx)
  333. nginxOn=true
  334. ;;
  335. *)
  336. comprobarError 1 100
  337. ;;
  338. esac
  339. # Otras opciones (FQDN)
  340. establecerFQDN
  341. }
  342. establecerFQDN() {
  343. while [ -z $hostname ]; do
  344. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" 20 70 --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  345. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  346. hostnamectl set-hostname $hostname
  347. else
  348. hostname=$(hostname)
  349. fi
  350. done
  351. #printf "\nHostname: $hostname\n"
  352. }
  353. instalarApache() {
  354. if [ $debianOS = true ];then
  355. result=$(apt-get -q -y install apache2 2>&1)
  356. comprobarError $? 101 $result
  357. elif [ $rhelOS = true ]; then
  358. result=$(yum -y install httpd 2>&1)
  359. comprobarError $? 101 $result
  360. else
  361. comprobarError 1 104
  362. fi
  363. }
  364. instalarNginx() {
  365. if [ $debianOS = true ];then
  366. result=$(apt-get -q -y install nginx 2>&1)
  367. comprobarError $? 102 $result
  368. elif [ $rhelOS = true ]; then
  369. # Hay que instalar primero otro repositorio
  370. result=$(yum -y install epel-release)
  371. comprobarError $? 103 $result
  372. result=$(yum -y install nginx 2>&1)
  373. comprobarError $? 102 $result
  374. else
  375. comprobarError 1 105
  376. fi
  377. }
  378. mostrarDatabase() {
  379. if [ $debianOS = true ]; then
  380. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  381. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  382. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  383. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  384. comprobarError $? 1
  385. case $database in
  386. MySQL)
  387. mySQLOn=true
  388. ;;
  389. MariaDB)
  390. mariaDBOn=true
  391. ;;
  392. *)
  393. comprobarError 1 200
  394. ;;
  395. esac
  396. elif [ $rhelOS = true ]; then
  397. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." 20 70 --yes-button "Continuar" --no-button "Salir"
  398. comprobarError $? 1
  399. mariaDBOn=true
  400. else
  401. comprobarError 1 200
  402. fi
  403. # Otras opciones (contraseña)
  404. leerSQLPasswd
  405. }
  406. leerSQLPasswd() {
  407. control=false
  408. error=""
  409. # Leemos la contreseña (stdin) y confirmamos
  410. while [ $control = false ]; do
  411. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  412. comprobarError $? 1
  413. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  414. comprobarError $? 1
  415. #printf "SQL Password 1: $sqlPasswd\n"
  416. #printf "SQL Password 2: $sqlPasswd2\n"
  417. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  418. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  419. elif [ $sqlPasswd != $sqlPasswd2 ];then
  420. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  421. else
  422. control=true
  423. fi
  424. done
  425. #printf "SQL Password: $sqlPasswd\n"
  426. unset control error sqlPasswd2
  427. }
  428. establecerSQLPasswd() {
  429. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  430. # Mejora: ¿Si ya tiene una contraseña asignada?
  431. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  432. if [ $? -eq 0 ];then
  433. # Establecemos contraseña del usuario root
  434. mysql -e "UPDATE mysql.user SET Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" > /dev/null 2>&1
  435. comprobarError $? 207
  436. # Desactivamos acceso root desde el exterior (solo localhost)
  437. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" > /dev/null 2>&1
  438. comprobarError $? 208
  439. # Eliminamos todos los usuarios anónimos
  440. mysql -e "DELETE FROM mysql.user WHERE User=''" > /dev/null 2>&1
  441. comprobarError $? 209
  442. # Eliminamos bases de datos 'test'
  443. mysql -e "DROP DATABASE IF EXISTS test" > /dev/null 2>&1
  444. comprobarError $? 210
  445. # Eliminamos privilegios de la base de datos 'test'
  446. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" > /dev/null 2>&1
  447. comprobarError $? 211
  448. # Aplicamos los cambios
  449. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  450. comprobarError $? 212
  451. else
  452. comprobarError $? 206
  453. fi
  454. }
  455. instalarMySQL() {
  456. if [ $debianOS = true ];then
  457. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  458. comprobarError $? 201 $result
  459. elif [ $rhelOS = true ]; then
  460. # MySQL no disponible en RHEL. 2 opciones:
  461. # 1) Instalar un repositorio adicional
  462. # 2) No instalar MySQL en distribuciones RHEL
  463. comprobarError 1 205
  464. else
  465. comprobarError 1 203
  466. fi
  467. }
  468. instalarMariaDB() {
  469. if [ $debianOS = true ];then
  470. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  471. comprobarError $? 202 $result
  472. elif [ $rhelOS = true ]; then
  473. result=$(yum -y install mariadb-server mariadb 2>&1)
  474. comprobarError $? 202 $result
  475. else
  476. comprobarError 1 204
  477. fi
  478. }
  479. habilitarServicio() {
  480. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  481. # Intentamos con systemctl (SystemD)
  482. printf "Habilitando servicio $1"
  483. if [ $# -le 0 ];then
  484. comprobarError 1 900
  485. fi
  486. which systemctl > /dev/null 2>&1
  487. if [ $? -eq 0 ]; then
  488. printf " (SystemD)..."
  489. systemctl start $1 > /dev/null 2>&1
  490. comprobarError $? 901 $1
  491. systemctl enable $1 > /dev/null 2>&1
  492. comprobarError $? 902 $1
  493. else
  494. # Intentamos con service (Upstart)
  495. which service > /dev/null 2>&1
  496. if [ $? -eq 0 ]; then
  497. printf " (Upstart)..."
  498. service $1 start > /dev/null 2>&1
  499. comprobarError $? 901 $1
  500. else
  501. # Intentamos con init.d (SystemV)
  502. printf " (SystemV)..."
  503. /etc/init.d/$1 start > /dev/null 2>&1
  504. comprobarError $? 901 $1
  505. fi
  506. # Intentamos habilitar en el arranque (Upstart)
  507. which update-rc.d > /dev/null 2>&1
  508. if [ $? -eq 0 ];then
  509. update-rc.d $1 enable
  510. comprobarError $? 902 $1
  511. else
  512. # Intentamos habilitar en el arranque (SystemV)
  513. which chkconfig > /dev/null 2>&1
  514. if [ $? -eq 0 ];then
  515. chkconfig $1 on
  516. comprobarError $? 902 $1
  517. else
  518. # ¿Qué mas opciones nos quedan?
  519. comprobarError 1 902 $1
  520. fi
  521. fi
  522. fi
  523. # Mejora: comprobar si el servicio está funcionando
  524. printf " OK.\n"
  525. }
  526. # Comprobación del sistema e inicialización
  527. comprobarRoot
  528. inicializarVariables
  529. OSInfo
  530. comprobarDependencias
  531. # Bienvenida
  532. mostrarBienvenida
  533. # Selección de componentes (express vs avanzada)
  534. mostrarExpress
  535. # Pre-configuración
  536. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  537. # Instalación
  538. # FALTA: whiptail --gauge -> Más bonito
  539. # Servidor Web
  540. if [ $apacheOn = true ]; then
  541. printf "Instalando Web Server Apache..."
  542. instalarApache
  543. printf " OK.\n"
  544. elif [ $nginxOn = true ]; then
  545. printf "Instalando Web Server Nginx..."
  546. instalarNginx
  547. printf " OK.\n"
  548. fi
  549. # Base de Datos
  550. if [ $mySQLOn = true ]; then
  551. printf "Instalando Base de Datos MySQL..."
  552. instalarMySQL
  553. printf " OK.\n"
  554. elif [ $mariaDBOn = true ]; then
  555. printf "Instalando Base de Datos MariaDB..."
  556. instalarMariaDB
  557. printf " OK.\n"
  558. fi
  559. # PHP
  560. if [ $phpOn = true ]; then
  561. printf "Instalando PHP-7..."
  562. printf " OK.\n"
  563. fi
  564. # SSL/TLS
  565. # Falta por implementar
  566. # MediaWiki
  567. if [ $mediaWikiOn = true ]; then
  568. printf "Instalando MediaWiki..."
  569. printf " OK.\n"
  570. fi
  571. # Moodle
  572. if [ $moodleOn = true ]; then
  573. printf "Instalando Moodle..."
  574. printf " OK.\n"
  575. fi
  576. # PRECAUCION!!!! Hay que habilitar algunos servicios antes de configurarlos
  577. # Por ejemplo: para cambiar la contraseña de root en mysql
  578. # Configuración
  579. # Configuración Apache
  580. # Virtual Hosts
  581. # Configuración Database
  582. # Arrancar Base de Datos, establecer contraseña y configuración segura
  583. if [ $mySQLOn = true ];then
  584. habilitarServicio mysql
  585. establecerSQLPasswd
  586. fi
  587. if [ $mariaDBOn = true ];then
  588. habilitarServicio mariadb
  589. establecerSQLPasswd
  590. fi
  591. # Configuración PHP
  592. # cgi.fix_pathinfo=0
  593. # Configurar máximo de subida de archivos
  594. # Configuración MediWiki
  595. # Configuración Moodle
  596. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  597. # Añadir reglas del cortafuegos
  598. # Configuración SSL/TLS
  599. # Generar certificados
  600. # Configurar certificados
  601. # Configurar actualizaciones
  602. if [ $actualizacionesOn = true ]; then
  603. printf "Configurando actualizaciones automáticas..."
  604. # CRONTAB
  605. printf " OK.\n"
  606. fi
  607. # Autodestrucción
  608. {
  609. for i in $(seq 0 5 50); do
  610. sleep 0.1
  611. echo $i
  612. done
  613. } | whiptail --gauge "Autodestrucción..." 7 70 0
  614. {
  615. for i in $(seq 50 5 100); do
  616. sleep 0.1
  617. echo $i
  618. done
  619. } | whiptail --gauge "Autopulverización..." 7 70 50